package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ServiceType;
import com.izouma.awesomeadmin.service.ServiceTypeService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/serviceType")
@RequiresAuthentication
public class ServiceTypeController {

    @Autowired
    private ServiceTypeService serviceTypeService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ServiceType record) {
        List<ServiceType> pp = serviceTypeService.getServiceTypeList(record);
        return new Result(true, pp);
    }

    /**
     * <p>首页获取全部记录。</p>
     * @param record
     * @return
     */
    @RequestMapping(value = "/home", method = RequestMethod.GET)
    @ResponseBody
    public Result home(ServiceType record) {
        List<ServiceType> pp = serviceTypeService.getServiceTypeListForHome(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getServiceType", method = RequestMethod.GET)
    @ResponseBody
    public Result getServiceType(@RequestParam(required = false, value = "id") String id) {
        ServiceType data = serviceTypeService.getServiceTypeById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ServiceType record) {
        ServiceType data = serviceTypeService.getServiceType(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ServiceType record) {
        Map<String, Object> result = new HashMap<>();

        List<ServiceType> pp =serviceTypeService.getServiceTypeByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ServiceType record) {
        boolean num = serviceTypeService.createServiceType(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateServiceType(ServiceType record) {
        boolean num = serviceTypeService.updateServiceType(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteServiceType(@RequestParam(required = true, value = "id") String id) {

        boolean num = serviceTypeService.deleteServiceType(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ServiceType record) throws Exception {

    List<ServiceType> serviceTypes = serviceTypeService.getServiceTypeList(record);


        String sheetName = "service_type";
        String titleName = "服务大类数据表";
        String fileName = "服务大类表";
        int columnNumber = 13;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "服务类型" ,   "简称" ,   "图片" ,   "颜色" ,   "排序" ,   "前台显示" ,   "描述"  };
        String[][] dataList = new String[serviceTypes.size()][13];

        for (int i = 0; i < serviceTypes.size(); i++) {

                        dataList[i][0] = String.valueOf(serviceTypes.get(i).getId());
                        dataList[i][1] = String.valueOf(serviceTypes.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(serviceTypes.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(serviceTypes.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(serviceTypes.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(serviceTypes.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(serviceTypes.get(i).getServiceType());
                        dataList[i][7] = String.valueOf(serviceTypes.get(i).getShortName());
                        dataList[i][8] = String.valueOf(serviceTypes.get(i).getImage());
                        dataList[i][9] = String.valueOf(serviceTypes.get(i).getColor());
                        dataList[i][10] = String.valueOf(serviceTypes.get(i).getRank());
                        dataList[i][11] = String.valueOf(serviceTypes.get(i).getShowFlag());
                        dataList[i][12] = String.valueOf(serviceTypes.get(i).getDescription());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

